diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index e3dbe592..8f3b0de2 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -387,14 +543,14 @@ class SquadService extends Actor {
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.Task = purpose
             UpdateSquadListWhenListed(squad, SquadInfo().Task(purpose))
-            UpdateSquadDetailWhenListed(squad.GUID, squad, SquadDetail().Task(purpose))
+            UpdateSquadDetail(squad.GUID, squad, SquadDetail().Task(purpose))
 
           case ChangeSquadZone(zone) =>
             log.info(s"${tplayer.Name}-${tplayer.Faction} has changed squad's ops zone to $zone")
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
             squad.ZoneId = zone.zoneId.toInt
             UpdateSquadListWhenListed(squad, SquadInfo().ZoneId(zone))
-            UpdateSquadDetailWhenListed(squad.GUID, squad, SquadDetail().ZoneId(zone))
+            UpdateSquadDetail(squad.GUID, squad, SquadDetail().ZoneId(zone))
 
           case CloseSquadMemberPosition(position) =>
             val squad = lSquadOpt.getOrElse(StartSquad(tplayer))
@@ -411,7 +567,7 @@ class SquadService extends Actor {
                 }
                 memberPosition.Close()
                 UpdateSquadListWhenListed(squad, listingChanged)
-                UpdateSquadDetailWhenListed(squad.GUID, squad,
+                UpdateSquadDetail(squad.GUID, squad,
                   SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail.Closed)))
                 )
               case Some(false) | None => ;
@@ -424,7 +580,7 @@ class SquadService extends Actor {
                 log.info(s"${tplayer.Name}-${tplayer.Faction} has opened the #$position position in squad")
                 squad.Availability.update(position, true)
                 UpdateSquadListWhenListed(squad, SquadInfo().Capacity(squad.Capacity))
-                UpdateSquadDetailWhenListed(squad.GUID, squad,
+                UpdateSquadDetail(squad.GUID, squad,
                   SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail.Open)))
                 )
               case Some(true) | None => ;
@@ -436,7 +592,7 @@ class SquadService extends Actor {
               case Some(true) =>
                 log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the role of squad position #$position")
                 squad.Membership(position).Role = role
-                UpdateSquadDetailWhenListed(squad.GUID, squad,
+                UpdateSquadDetail(squad.GUID, squad,
                   SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().Role(role))))
                 )
               case Some(false) | None => ;
@@ -448,7 +604,7 @@ class SquadService extends Actor {
               case Some(true) =>
                 log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the orders for squad position #$position")
                 squad.Membership(position).Orders = orders
-                UpdateSquadDetailWhenListed(squad.GUID, squad,
+                UpdateSquadDetail(squad.GUID, squad,
                   SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().DetailedOrders(orders))))
                 )
               case Some(false) | None => ;
@@ -460,7 +616,7 @@ class SquadService extends Actor {
               case Some(true) =>
                 log.info(s"${tplayer.Name}-${tplayer.Faction} has changed the requirements for squad position #$position")
                 squad.Membership(position).Requirements = certs
-                UpdateSquadDetailWhenListed(squad.GUID, squad,
+                UpdateSquadDetail(squad.GUID, squad,
                   SquadDetail().Members(List(SquadPositionEntry(position, SquadPositionDetail().Requirements(certs))))
                 )
               case Some(false) | None => ;
@@ -519,7 +675,7 @@ class SquadService extends Actor {
             squad.LocationFollowsSquadLead = false
             squad.AutoApproveInvitationRequests = false
             UpdateSquadListWhenListed(squad, SquadInfo().Task("").ZoneId(None).Capacity(squad.Capacity))
-            UpdateSquadDetailWhenListed(squad.GUID, squad)
+            UpdateSquadDetail(squad.GUID, squad)
 
           case _ =>
         }
@@ -530,6 +686,9 @@ class SquadService extends Actor {
             log.info(s"${tplayer.Name} would like the #${position+1} spot in this squad")
             val membership = squad.Membership.zipWithIndex
             val toMember = squad.Membership(position)
+            if(squad.Leader.CharId == tplayer.CharId) {
+              //TODO squad leader currently disallowed
+            } else
             //the squad leader may swap to any open position; a normal member has to validate against requirements
             if((squad.Leader.CharId == tplayer.CharId && toMember.CharId == 0) || ValidOpenSquadPosition(squad, position, toMember, tplayer.Certifications)) {
               membership.find { case (member, _) => member.CharId == tplayer.CharId } match {
@@ -538,12 +697,15 @@ class SquadService extends Actor {
                   if(fromIndex == squad.LeaderPositionIndex) {
                     squad.LeaderPositionIndex = position
                   }
+                  //RemoveInvite(tplayer.CharId).foreach { _ =>
+                    //close the old bids out
+                  //}
                   membership
                     .filter { case (_member, _) => _member.CharId > 0 }
                     .foreach { case (_member, _) =>
                       SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.AssignMember(squad, fromIndex, position)))
                     }
-                  UpdateSquadDetailWhenListed(squad.GUID, squad)
+                  UpdateSquadDetail(squad.GUID, squad)
                 case _ => ;
                 //somehow, this is not our squad; do nothing, for now
               }
@@ -561,10 +723,14 @@ class SquadService extends Actor {
                 if(ValidOpenSquadPosition(squad, position, toMember, tplayer.Certifications)) {
                   //we could join but we may need permission from the squad leader first
                   log.info(s"Player ${tplayer.Name} would like to join the squad ${squad.Task}.")
-                  bids(tplayer.CharId) = NormalBid(squad.Leader.CharId, guid, position)
-                  //val leader = squad.Leader
-                  //TODO ask permission from the squad leader, unless auto-approve is in effect
-                  self ! SquadServiceMessage(tplayer, SquadAction.Membership(SquadRequestType.Accept, tplayer.CharId, None, "", None))
+                  val leader = squad.Leader
+                  val bid = BidForPosition(tplayer, guid, position)
+                  val leaderCharId = leader.CharId
+                  AddInvite(leaderCharId, bid) match {
+                    case out @ Some(_) if out.contains(bid) =>
+                      HandleBidForPosition(bid, tplayer)
+                    case _ => ;
+                  }
                 }
               case None => ;
               //squad does not exist? assume old local data; force update to correct discrepancy
@@ -574,16 +740,19 @@ class SquadService extends Actor {
           case (Some(squad), AssignSquadMemberToRole(position, char_id)) =>
             val membership = squad.Membership.zipWithIndex
             (membership.find({ case (member, _) => member.CharId == char_id}), membership(position)) match {
-              case (Some((fromMember, fromPosition)), (toMember, _)) =>
+              //TODO squad leader currently disallowed
+              case (Some((fromMember, fromPosition)), (toMember, _)) if fromPosition != 0 =>
                 val name = fromMember.Name
                 SwapMemberPosition(squad, toMember, fromMember)
-                //
+                if(fromPosition == squad.LeaderPositionIndex) {
+                  squad.LeaderPositionIndex = position
+                }
                 membership
                   .filter({ case (_member, _) => _member.CharId > 0 })
                   .foreach { case (_member, _) =>
                     SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.AssignMember(squad, fromPosition, position)))
                   }
-                UpdateSquadDetailWhenListed(squad.GUID, squad,
+                UpdateSquadDetail(squad.GUID, squad,
                   SquadDetail().Members(List(
                     SquadPositionEntry(position, SquadPositionDetail().CharId(fromMember.CharId).Name(fromMember.Name)),
                     SquadPositionEntry(fromPosition, SquadPositionDetail().CharId(char_id).Name(name))
@@ -597,7 +766,15 @@ class SquadService extends Actor {
             idToSquad.get(guid) match {
               case Some(squad) =>
                 viewDetails(tplayer.CharId) = guid
-                sender ! SquadServiceResponse(s"/${tplayer.CharId}/Squad", SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
+                sender ! SquadServiceResponse("", SquadResponse.Detail(squad.GUID, SquadService.Detail.Publish(squad)))
+              case None => ;
+            }
+
+          //the following message is feedback from a specific client, awaiting proper initialization
+          case (_, DisplayFullSquad()) =>
+            idToSquad.get(guid) match {
+              case Some(squad) =>
+                sender ! SquadServiceResponse("", SquadResponse.InitSquad(squad.GUID))
               case None => ;
             }
 
@@ -609,6 +786,122 @@ class SquadService extends Actor {
     }
   }
 
+  /**
+    *
+    * @param invitedPlayer
+    * @param bid
+    * @return an optional invite;
+    *         if added to the active invite position, return the parameter bid;
+    *         if added to the queued invite, return the invite in the active position;
+    *         if not added, return `None`
+    */
+  def AddInvite(invitedPlayer : Long, bid : Invitation) : Option[Invitation] = {
+    invites.get(invitedPlayer) match {
+      case Some(_bid) =>
+        queuedInvites.get(invitedPlayer) match {
+          case Some(bidList) =>
+            if(_bid.InviterCharId != bid.InviterCharId && !bidList.exists { eachBid => eachBid.InviterCharId == bid.InviterCharId }) {
+              log.debug(s"Invite from ${bid.InviterCharId} to $invitedPlayer stored in queue while active invite request pending")
+              queuedInvites(invitedPlayer) = bid match {
+                case _: BidForPosition =>
+                  val (normals, others) = bidList.partition(_.isInstanceOf[BidForPosition])
+                  (normals :+ bid) ++ others
+                case _ =>
+                  bidList :+ bid
+              }
+              None
+            }
+            else {
+              Some(_bid)
+            }
+          case None =>
+            if(_bid.InviterCharId != bid.InviterCharId) {
+              log.debug(s"Invite from ${bid.InviterCharId} to $invitedPlayer stored while active invite request pending")
+              queuedInvites(invitedPlayer) = List[Invitation](bid)
+            }
+            Some(_bid)
+        }
+
+      case None =>
+        invites(invitedPlayer) = bid
+        Some(bid)
+    }
+  }
+
+  def RemoveInvite(invitedPlayer : Long) : Option[Invitation] = {
+    invites.remove(invitedPlayer)
+  }
+
+  def RemoveQueuedInvites(invitedPlayer : Long) : List[Invitation] = {
+    queuedInvites.remove(invitedPlayer) match {
+      case Some(_bidList) => _bidList.toList
+      case None => Nil
+    }
+  }
+
+  def RemoveInvites(invitedPlayer : Long, invitingPlayer : Long) : Unit = {
+    queuedInvites.get(invitedPlayer) match {
+      case Some(bidList) =>
+        val list = bidList.filterNot { _.InviterCharId == invitingPlayer }
+        if(list.nonEmpty) {
+          queuedInvites(invitedPlayer) = list
+        }
+        else {
+          queuedInvites.remove(invitedPlayer)
+        }
+      case None => ;
+    }
+    invites.get(invitedPlayer) match {
+      case Some(_bid) =>
+        if(_bid.InviterCharId == invitingPlayer) {
+          //drop bid, try reload new bid
+        }
+      case None => ;
+    }
+  }
+
+  def NextInvite(invitedPlayer : Long) : Option[Invitation] = {
+    invites.get(invitedPlayer) match {
+      case None =>
+        queuedInvites.get(invitedPlayer) match {
+          case Some(list) =>
+            list match {
+              case Nil =>
+                None
+              case x :: Nil =>
+                invites(invitedPlayer) = x
+                queuedInvites.remove(invitedPlayer)
+                Some(x)
+              case x :: xs =>
+                invites(invitedPlayer) = x
+                queuedInvites(invitedPlayer) = xs
+                Some(x)
+            }
+
+          case None =>
+            None
+        }
+      case Some(_) =>
+        None
+    }
+  }
+
+  def HandleBidForPosition(bid : BidForPosition, player : Player) : Unit = {
+    idToSquad.get(bid.squad_guid) match {
+      case Some(squad) =>
+        val leaderCharId = squad.Leader.CharId
+        if(squad.AutoApproveInvitationRequests) {
+          self ! SquadServiceMessage(player, SquadAction.Membership(SquadRequestType.Accept, leaderCharId, None, "", None))
+        }
+        else {
+          SquadEvents.publish(SquadServiceResponse(s"/$leaderCharId/Squad", SquadResponse.WantsSquadPosition(bid.player.Name)))
+        }
+      case _ =>
+        //squad is missing; will this properly short-circuit?
+        log.error(s"Attempted to process ${bid.InviterName}'s bid for a position in a squad (id:${bid.squad_guid.guid}) that does not exist")
+    }
+  }
+
   def JoinSquad(player : Player, squad : Squad, line : Int) : Boolean = {
     val charId = player.CharId
     val position = squad.Membership(line)
@@ -652,7 +945,7 @@ class SquadService extends Actor {
           .foreach { member =>
             SquadEvents.publish(SquadServiceResponse(s"/${member.CharId}/Squad", SquadResponse.Join(squad, updatedIndex)))
           }
-        UpdateSquadDetailWhenListed(squad.GUID, squad,
+        UpdateSquadDetail(squad.GUID, squad,
           SquadDetail().Members(List(SquadPositionEntry(line, SquadPositionDetail().CharId(charId).Name(player.Name))))
         )
       }
@@ -670,30 +963,18 @@ class SquadService extends Actor {
     membership.find { case (_member, _) => _member.CharId == charId } match {
       case Some((member, index)) =>
         val updateList = membership.collect({ case (_member, _index) if _member.CharId > 0 => (_member.CharId, _index) }).toList
+        //member leaves the squad completely
         memberToSquad.remove(charId)
         member.Name = ""
         member.CharId = 0
-
-        val size = squad.Size
-        if(size < 2) {
-          //squad is rendered to just one person or less; collapse it
-          squad.Membership.foreach { _member =>
-              SquadEvents.publish(SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.Membership(SquadResponseType.Disband, 0, 0, charId, None, "", false, Some(None))))
+        sender ! SquadServiceResponse("", SquadResponse.Leave(squad, updateList))
+        //other squad members see the member leaving
+        val leavingMember = List((charId, index))
+        membership
+          .filter { case (_member, _) => _member.CharId > 0 }
+          .foreach { case (_member, _) =>
+            SquadEvents.publish( SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.Leave(squad, leavingMember)) )
           }
-          CloseOutSquad(squad, membership, updateList)
-        }
-        else {
-          //squad continues, despite player's parting
-          //member leaves the squad completely
-          sender ! SquadServiceResponse("", SquadResponse.Leave(squad, updateList))
-          //other squad members see the member leaving
-          val leavingMember = List((charId, index))
-          membership
-            .filter { case (_member, _) => _member.CharId > 0 }
-            .foreach { case (_member, _) =>
-              SquadEvents.publish( SquadServiceResponse(s"/${_member.CharId}/Squad", SquadResponse.Leave(squad, leavingMember)) )
-            }
-        }
         true
       case None =>
         false
@@ -720,6 +1001,7 @@ class SquadService extends Actor {
         SquadEvents.publish( SquadServiceResponse(s"/$charId/Squad", SquadResponse.Leave(squad, updateList)) )
     }
     idToSquad.remove(squad.GUID)
+    UpdateSquadList(squad, None)
   }
 
   def SwapMemberPosition(squad : Squad, toMember : Member, fromMember : Member) : Unit = {
@@ -744,6 +1026,13 @@ class SquadService extends Actor {
     toMember.Armor = armor
   }
 
+  def UpdateSquadList(faction : PlanetSideEmpire.Value): Unit = {
+    val factionListings = publishedLists(faction)
+    SquadEvents.publish(
+      SquadServiceResponse(s"/$faction/Squad", SquadResponse.InitList(factionListings.toVector))
+    )
+  }
+
   def UpdateSquadList(squad : Squad, changes : SquadInfo) : Unit = {
     UpdateSquadList(squad, Some(changes))
   }
@@ -759,7 +1048,6 @@ class SquadService extends Actor {
   }
 
   def UpdateSquadList(squad : Squad, changes : Option[SquadInfo]) : Unit = {
-    val entry = SquadService.SquadList.Publish(squad)
     val faction = squad.Faction
     val factionListings = publishedLists(faction)
     factionListings.find(info => {
@@ -774,7 +1062,7 @@ class SquadService extends Actor {
           case Some(changedFields) =>
             //squad information update
             log.info(s"Squad will be updated")
-            factionListings(index) = entry
+            factionListings(index) = SquadService.SquadList.Publish(squad)
             SquadEvents.publish(
               SquadServiceResponse(s"/$faction/Squad", SquadResponse.UpdateList(Seq((index, changedFields))))
             )
@@ -790,7 +1078,7 @@ class SquadService extends Actor {
       case None =>
         //first time being published
         log.info(s"Squad will be introduced")
-        factionListings += entry
+        factionListings += SquadService.SquadList.Publish(squad)
         SquadEvents.publish(
           SquadServiceResponse(s"/$faction/Squad", SquadResponse.InitList(factionListings.toVector))
         )
@@ -798,19 +1086,7 @@ class SquadService extends Actor {
   }
 
   def UpdateSquadDetail(guid : PlanetSideGUID, squad : Squad) : Unit = {
-    UpdateSquadDetailWhenListed(guid, squad, SquadService.Detail.Publish(squad))
-  }
-
-  def UpdateSquadDetailWhenListed(guid : PlanetSideGUID, squad : Squad) : Unit = {
-    if(squad.Listed || squad.Size > 1) {
-      UpdateSquadDetail(guid, squad, SquadService.Detail.Publish(squad))
-    }
-  }
-
-  def UpdateSquadDetailWhenListed(guid : PlanetSideGUID, squad : Squad, detail : SquadDetail) : Unit = {
-    if(squad.Listed || squad.Size > 1) {
-      UpdateSquadDetail(guid, squad, detail)
-    }
+    UpdateSquadDetail(guid, squad, SquadService.Detail.Publish(squad))
   }
 
   def UpdateSquadDetail(guid : PlanetSideGUID, squad : Squad, detail : SquadDetail) : Unit = {
@@ -824,13 +1100,19 @@ class SquadService extends Actor {
 }
 
 object SquadService {
-  trait PositionBid
+  abstract class Invitation(char_id : Long, name : String) {
+    def InviterCharId : Long = char_id
+    def InviterName : String = name
+  }
 
-  final case class NormalBid(char_id : Long, squad_guid : PlanetSideGUID, position : Int) extends PositionBid
+  final case class BidForPosition(player : Player, squad_guid : PlanetSideGUID, position : Int)
+    extends Invitation(player.CharId, player.Name)
 
-  final case class VacancyBid(char_id : Long, squad_guid : PlanetSideGUID) extends PositionBid
+  final case class VacancyInvite(char_id : Long, name : String, squad_guid : PlanetSideGUID)
+    extends Invitation(char_id, name)
 
-  final case class SpontaneousBid(char_id : Long, placeholder : Squad) extends PositionBid
+  final case class SpontaneousInvite(player : Player)
+    extends Invitation(player.CharId, player.Name)
 
   object SquadList {
     def Publish(squad : Squad) : SquadInfo = {
diff --git a/common/src/test/scala/game/SquadDefinitionActionMessageTest.scala b/common/src/test/scala/game/SquadDefinitionActionMessageTest.scala
index 09e2cd42..3ef29577 100644
--- a/common/src/test/scala/game/SquadDefinitionActionMessageTest.scala
+++ b/common/src/test/scala/game/SquadDefinitionActionMessageTest.scala
@@ -222,7 +222,7 @@ class SquadDefinitionActionMessageTest extends Specification {
       case SquadDefinitionActionMessage(unk1, unk2, action) =>
         unk1 mustEqual PlanetSideGUID(0)
         unk2 mustEqual 0
-        action mustEqual SearchForSquadsWithParticularRole("Badass", 0L, 1, 0)
+        action mustEqual SearchForSquadsWithParticularRole("Badass", Set(), 1, SearchMode.AnyPositions)
       case _ =>
         ko
     }
@@ -233,7 +233,7 @@ class SquadDefinitionActionMessageTest extends Specification {
       case SquadDefinitionActionMessage(unk1, unk2, action) =>
         unk1 mustEqual PlanetSideGUID(0)
         unk2 mustEqual 0
-        action mustEqual SearchForSquadsWithParticularRole("Badass", 0L, 2, 0)
+        action mustEqual SearchForSquadsWithParticularRole("Badass", Set(), 2, SearchMode.AnyPositions)
       case _ =>
         ko
     }
@@ -244,7 +244,7 @@ class SquadDefinitionActionMessageTest extends Specification {
       case SquadDefinitionActionMessage(unk1, unk2, action) =>
         unk1 mustEqual PlanetSideGUID(0)
         unk2 mustEqual 0
-        action mustEqual SearchForSquadsWithParticularRole("Badass", 0L, 2, 1)
+        action mustEqual SearchForSquadsWithParticularRole("Badass", Set(), 2, SearchMode.AvailablePositions)
       case _ =>
         ko
     }
@@ -255,7 +255,7 @@ class SquadDefinitionActionMessageTest extends Specification {
       case SquadDefinitionActionMessage(unk1, unk2, action) =>
         unk1 mustEqual PlanetSideGUID(0)
         unk2 mustEqual 0
-        action mustEqual SearchForSquadsWithParticularRole("Badass", 536870928L, 2, 2)
+        action mustEqual SearchForSquadsWithParticularRole("Badass", Set(CertificationType.InfiltrationSuit, CertificationType.AntiVehicular), 2, SearchMode.SomeCertifications)
       case _ =>
         ko
     }
@@ -266,7 +266,7 @@ class SquadDefinitionActionMessageTest extends Specification {
       case SquadDefinitionActionMessage(unk1, unk2, action) =>
         unk1 mustEqual PlanetSideGUID(0)
         unk2 mustEqual 0
-        action mustEqual SearchForSquadsWithParticularRole("Badass", 536870928L, 2, 3)
+        action mustEqual SearchForSquadsWithParticularRole("Badass", Set(CertificationType.InfiltrationSuit, CertificationType.AntiVehicular), 2, SearchMode.AllCertifications)
       case _ =>
         ko
     }
@@ -436,35 +436,35 @@ class SquadDefinitionActionMessageTest extends Specification {
   }
 
   "encode (34a)" in {
-    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SearchForSquadsWithParticularRole("Badass", 0L, 1, 0))
+    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SearchForSquadsWithParticularRole("Badass", Set(), 1, SearchMode.AnyPositions))
     val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
     pkt mustEqual string_34a
   }
 
   "encode (34b)" in {
-    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SearchForSquadsWithParticularRole("Badass", 0L, 2, 0))
+    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SearchForSquadsWithParticularRole("Badass", Set(), 2, SearchMode.AnyPositions))
     val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
     pkt mustEqual string_34b
   }
 
   "encode (34c)" in {
-    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SearchForSquadsWithParticularRole("Badass", 0L, 2, 1))
+    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SearchForSquadsWithParticularRole("Badass", Set(), 2, SearchMode.AvailablePositions))
     val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
     pkt mustEqual string_34c
   }
 
   "encode (34d)" in {
-    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SearchForSquadsWithParticularRole("Badass", 536870928L, 2, 2))
+    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SearchForSquadsWithParticularRole("Badass", Set(CertificationType.InfiltrationSuit, CertificationType.AntiVehicular), 2, SearchMode.SomeCertifications))
     val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
     pkt mustEqual string_34d
   }
 
   "encode (34e)" in {
-    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SearchForSquadsWithParticularRole("Badass", 536870928L, 2, 3))
+    val msg = SquadDefinitionActionMessage(PlanetSideGUID(0), 0, SearchForSquadsWithParticularRole("Badass", Set(CertificationType.InfiltrationSuit, CertificationType.AntiVehicular), 2, SearchMode.AllCertifications))
     val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
 
     pkt mustEqual string_34e
diff --git a/common/src/test/scala/game/SquadMemberEventTest.scala b/common/src/test/scala/game/SquadMemberEventTest.scala
index 5ecc1cef..2f431991 100644
--- a/common/src/test/scala/game/SquadMemberEventTest.scala
+++ b/common/src/test/scala/game/SquadMemberEventTest.scala
@@ -12,7 +12,7 @@ class SquadMemberEventTest extends Specification {
   "decode" in {
     PacketCoding.DecodePacket(string).require match {
       case SquadMemberEvent(u1, u2, u3, u4, u5, u6, u7) =>
-        u1 mustEqual 0
+        u1 mustEqual MemberEvent.Add
         u2 mustEqual 7
         u3 mustEqual 42771010L
         u4 mustEqual 0
@@ -25,7 +25,7 @@ class SquadMemberEventTest extends Specification {
   }
 
   "encode" in {
-    val msg = SquadMemberEvent(0, 7, 42771010L, 0, Some("HofD"), Some(7), Some(529745L))
+    val msg = SquadMemberEvent(MemberEvent.Add, 7, 42771010L, 0, Some("HofD"), Some(7), Some(529745L))
     val pkt = PacketCoding.EncodePacket(msg).require.toByteVector
     pkt mustEqual string
   }
